summaryrefslogtreecommitdiff
path: root/tests.branching/merge-with-chunk-repo-moved.script
diff options
context:
space:
mode:
Diffstat (limited to 'tests.branching/merge-with-chunk-repo-moved.script')
-rwxr-xr-xtests.branching/merge-with-chunk-repo-moved.script53
1 files changed, 53 insertions, 0 deletions
diff --git a/tests.branching/merge-with-chunk-repo-moved.script b/tests.branching/merge-with-chunk-repo-moved.script
new file mode 100755
index 00000000..c67ccc6d
--- /dev/null
+++ b/tests.branching/merge-with-chunk-repo-moved.script
@@ -0,0 +1,53 @@
+#!/bin/sh
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# "morph merge" should detect changes in a repo that was added as part of the
+# branch and warn the user that the changes will not be merged automatically
+
+set -eu
+
+# Create system branch.
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" init
+"$SRCDIR/scripts/test-morph" branch baserock:morphs baserock/newbranch
+
+"$SRCDIR/scripts/test-morph" edit hello-system hello-stratum hello
+
+# Chunk moves to a new location (we manually update the ref back to master
+# here, so 'morph edit' can create a system branch in the new repo from it).
+git clone -q "$DATADIR/hello" "$DATADIR/hello-lorried"
+cd "$DATADIR/workspace/baserock/newbranch/baserock:morphs"
+sed -e 's/"repo": "baserock:hello"/"repo": "baserock:hello-lorried"/' \
+ -e 's/"ref": "baserock\/newbranch"/"ref": "master"/' \
+ -i hello-stratum.morph
+git commit -q --all -m "'hello' repository has moved"
+
+# Now we further edit the chunk, just for fun.
+"$SRCDIR/scripts/test-morph" edit hello-system hello-stratum hello
+cd "$DATADIR/workspace/baserock/newbranch/baserock:hello-lorried"
+touch newfile.txt
+git add newfile.txt
+git commit -m "Add new file" --quiet
+
+cd "$DATADIR/workspace/baserock/newbranch/baserock:morphs"
+git commit -q --all -m "Update system branch refs"
+
+# Try to merge changes back to master (should fail, because we don't support
+# adding chunks inside branches yet).
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" checkout baserock:morphs master
+cd master
+"$SRCDIR/scripts/test-morph" merge baserock/newbranch